#!/usr/bin/env python

import os
import sys
import shutil
import argparse

#_________________________________________________________________________________________
#                   INIT (USER-SPECIFIC)
if sys.platform == 'linux2' or sys.platform == 'darwin': docs="Documents"
if sys.platform == 'win32': docs="My Documents"

HOME=os.path.expanduser("~")
project_folder = os.path.join(os.path.join(HOME,'Dropbox'),'projects')
skel = os.path.join(project_folder,'skeleton')
del project_folder
#_________________________________________________________________________________________
#                   TOOLS
def read(fname):
    temp = open(fname,'r')
    data = temp.read()
    temp.close()
    del temp
    return data

def buff():
    return "="*72
#_________________________________________________________________________________________
#                   Copy Skeleton folder
def parse_path(path):
    path=list(path)
    if path[0] == "~":
        path[0] = HOME
    return ''.join(path)

def create(source=None,dest=None):
    if not source:
        source = skel
    if not dest:
        print "I don't know where to copy the skeleton directory!"
        sys.exit(1)
    src=parse_path(source)
    dst=parse_path(dest)
    try:
        shutil.copytree(src,dst)
    except:
        print "Error copying tree @ '%s'" % dst
        print "Maybe it already exists?"
#_________________________________________________________________________________________
#                   Parse Args

def parse_args():

    parser = argparse.ArgumentParser(
        prog="skel",
        description="Purpose: A command line tool to copy the skeleton directory to the desired location.",
        epilog="Default skeleton directory located @ '%s'" % skel
    )
    parser.add_argument('-c','--clone',help="Path to clone skeleton directory.",dest='clone')
    parser.add_argument('-s','--skel',help="Path to actual skeleton directory.",dest='skel')
    args = parser.parse_args()
    return {'clone':args.clone,'skel':args.skel}
#_________________________________________________________________________________________
#                   Wrapper

def main():
    args=parse_args()
    create(args['skel'],args['clone'])

if __name__ == "__main__":
    main()
